## postgresql-pllua 2.0.12

=== Makefile ===
# Makefile for PL/Lua		# -*- mode: makefile-gmake -*-

PG_CONFIG ?= pg_config

# Lua specific

# two values can be set here, which only apply to luajit:
#  -DNO_LUAJIT        disables all use of luajit features
#  -DUSE_INT8_CDATA   convert sql bigints to cdata int64_t
# The latter is off by default because it has some possibly
# undesirable effects on bigint handling.

PLLUA_CONFIG_OPTS ?=

# General
LUA_INCDIR ?= /usr/local/include/lua53
LUALIB ?= -L/usr/local/lib -llua-5.3
LUAC ?= luac53
LUA ?= lua53

# LuaJIT
#LUA_INCDIR = /usr/local/include/luajit-2.1
#LUALIB = -L/usr/local/lib -lluajit-5.1
#LUAJIT = luajit

ifdef LUAJIT
LUAJITC ?= $(LUAJIT) -b -g -t raw
LUA = $(LUAJIT)
LUAC = $(REORDER_O) $(LUAJITC)
endif

LUAVER = $(shell $(LUA) -e 'print(_VERSION:match("^Lua ([0-9.]+)"))')
ifeq ($(filter 5.1 5.3 5.4, $(LUAVER)),)
$(error failed to get valid lua version)
endif

# if no OBJCOPY or not needed, this can be set to true (or false)
OBJCOPY ?= objcopy

# We expect $(BIN_LD) -o foo.o foo.luac to create a foo.o with the
# content of foo.luac as a data section (plus appropriate symbols).
# GNU LD and compatible linkers (including recent clang lld) should be
# fine with -r -b binary, but this does break on some ports.

BIN_LD ?= $(LD) -r -b binary

# If BIN_ARCH and BIN_FMT are defined, we assume LD_BINARY is broken
# and do this instead. This is apparently needed for linux-mips64el,
# for which BIN_ARCH=mips:isa64r2 BIN_FMT=elf64-tradlittlemips seems
# to work.

ifdef BIN_ARCH
ifdef BIN_FMT
BIN_LD = $(REORDER_O) $(OBJCOPY) -B $(BIN_ARCH) -I binary -O $(BIN_FMT)
endif
endif

# should be no need to edit below here

MODULE_big = pllua

EXTENSION = pllua plluau

SQL_SRC = pllua--2.0.sql pllua--1.0--2.0.sql \
	  plluau--2.0.sql plluau--1.0--2.0.sql
DATA = $(addprefix scripts/, $(SQL_SRC))

DOC_HTML = pllua.html

ifdef BUILD_DOCS
DOCS = $(DOC_HTML)
ifdef BUILD_ICON
ICON = icon.meta
endif
endif

objdir := src

# variables like $(srcdir) and $(MAJORVERSION) are not yet set, but
# are safe to use in recursively-expanded variables since they will be
# set before most values are needed. Can't use them in conditionals
# until after pgxs is loaded though.

# version-dependent regression tests
REGRESS_V10 := triggers_10
REGRESS_V11 := procedures

REGRESS_LUA_5.4 := lua54

EXTRA_REGRESS = $(REGRESS_BY_VERSION) $(REGRESS_LUA_$(LUAVER))

define REGRESS_BY_VERSION
$(strip
   $(foreach v,$(filter REGRESS_V%,$(.VARIABLES)),
      $(if $(call version_ge,$(MAJORVERSION),$(subst REGRESS_V,,$(v))),
           $($(v)))))
endef

REGRESS = --schedule=$(srcdir)/serial_schedule $(EXTRA_REGRESS)
REGRESS_PARALLEL = --schedule=$(srcdir)/parallel_schedule $(EXTRA_REGRESS)

REORDER_O = $(srcdir)/tools/reorder-o.sh

DOC_MD = css.css script.js intro.md pllua.md building.md endnote.md

DOC_SRCS = logo.css $(ICON) $(addprefix $(srcdir)/doc/, $(DOC_MD))

INCS=   pllua.h pllua_pgver.h pllua_luaver.h pllua_luajit.h

HEADERS= $(addprefix src/, $(INCS))

OBJS_C= compile.o datum.o elog.o error.o exec.o globals.o init.o \
	jsonb.o numeric.o objects.o paths.o pllua.o preload.o spi.o \
	time.o trigger.o trusted.o

SRCS_C = $(addprefix $(srcdir)/src/, $(OBJS_C:.o=.c))

OBJS_LUA = compat.o

SRCS_LUA = $(addprefix $(srcdir)/src/, $(OBJS_LUA:.o=.lua))

OBJS = $(addprefix src/, $(OBJS_C))

EXTRA_OBJS = $(addprefix src/, $(OBJS_LUA))

EXTRA_CLEAN = pllua_functable.h plerrcodes.h \
	$(addprefix src/,$(OBJS_LUA:.o=.luac)) $(EXTRA_OBJS) \
	logo.css tmpdoc.html icon-16.png icon.meta $(DOC_HTML)

PG_CPPFLAGS = -I$(LUA_INCDIR) $(PLLUA_CONFIG_OPTS)

SHLIB_LINK = $(EXTRA_OBJS) $(LUALIB)

# if VPATH is not already set, but the makefile is not in the current
# dir, then assume a vpath build using the makefile's directory as
# source. PGXS will set $(srcdir) accordingly.
ifndef VPATH
ifneq ($(realpath $(CURDIR)),$(realpath $(dir $(firstword $(MAKEFILE_LIST)))))
VPATH := $(dir $(firstword $(MAKEFILE_LIST)))
endif
endif

mklibdir := $(if $(VPATH),$(VPATH)/tools,tools)
include $(mklibdir)/numeric.mk

# actually load pgxs

PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)

# definitions that must follow pgxs

ifeq ($(call version_ge,$(MAJORVERSION),9.5),)
$(error unsupported PostgreSQL version)
endif

$(OBJS): $(addprefix $(srcdir)/src/, $(INCS))

# for a vpath build, we need src/ to exist in the build dir before
# building any objects.
ifdef VPATH
all: vpath-mkdirs
.PHONY: vpath-mkdirs
$(OBJS) $(EXTRA_OBJS): | vpath-mkdirs

vpath-mkdirs:
	$(MKDIR_P) $(objdir)
endif # VPATH

all: $(DOCS)

# explicit deps on generated includes
src/init.o: pllua_functable.h
src/error.o: plerrcodes.h

$(shlib): $(EXTRA_OBJS)

%.luac: %.lua
	$(LUAC) -o $@ $<

ifeq ($(PORTNAME),darwin)
# Apple of course has to do its own thing when it comes to object file
# format and linker options.

_stub.c:
	touch $@

%.o: %.luac _stub.o
	$(LD) -r -sectcreate binary $(subst .,_,$(<F)) $< _stub.o -o $@

else
# The objcopy here is optional, it's just cleaner for the loaded data
# to be in a readonly section. So we ignore errors on it.

%.o: %.luac
	$(BIN_LD) -o $@ $<
	-$(OBJCOPY) --rename-section .data=.rodata,contents,alloc,load,readonly $@
endif

pllua_functable.h: $(SRCS_C) $(srcdir)/tools/functable.lua
	$(LUA) $(srcdir)/tools/functable.lua $(SRCS_C) >$@

ifneq ($(call version_ge,$(MAJORVERSION),11),)

#in pg 11+, we can get the server's errcodes.txt.
plerrcodes.h: $(datadir)/errcodes.txt $(srcdir)/tools/errcodes.lua
	$(LUA) $(srcdir)/tools/errcodes.lua $(datadir)/errcodes.txt >plerrcodes.h

else

plerrcodes.h: $(srcdir)/src/plerrcodes_old.h
	cp $(srcdir)/src/plerrcodes_old.h plerrcodes.h

endif

installcheck-parallel: submake $(REGRESS_PREP)
	$(pg_regress_installcheck) $(REGRESS_OPTS) $(REGRESS_PARALLEL)

logo.css: $(srcdir)/doc/logo.svg $(srcdir)/tools/logo.lua
	$(LUA) $(srcdir)/tools/logo.lua -text -logo $(srcdir)/doc/logo.svg >$@

# Stripped PNGs are quite a bit smaller than .ico
#icon.ico: $(srcdir)/doc/logo.svg
#	convert -size 256x256 -background transparent $(srcdir)/doc/logo.svg \
#		-format ico -define icon:auto-resize=32,16 icon.ico

icon-16.png: $(srcdir)/doc/logo.svg
	convert -size 16x16 -background transparent $(srcdir)/doc/logo.svg \
		-format png -define png:format=png32 \
		-define png:exclude-chunk=all icon-16.png

icon.meta: icon-16.png
	$(LUA) $(srcdir)/tools/logo.lua -binary -icon="16x16" icon-16.png >$@

$(DOC_HTML): $(DOC_SRCS) $(srcdir)/doc/template.xsl $(srcdir)/tools/doc.sh
	$(srcdir)/tools/doc.sh $(DOC_SRCS) >tmpdoc.html
	xsltproc --encoding utf-8 $(srcdir)/doc/template.xsl tmpdoc.html >$@
	rm -- tmpdoc.html

=== hstore/Makefile ===
# Makefile for PL/Lua + hstore

PG_CONFIG ?= pg_config

# Lua specific

# General
LUA_INCDIR ?= /usr/local/include/lua53
LUALIB ?= -L/usr/local/lib -llua-5.3

# no need to edit below here

MODULE_big = hstore_pllua

EXTENSION = hstore_pllua hstore_plluau

DATA = hstore_pllua--1.0.sql hstore_plluau--1.0.sql

OBJS =	hstore_pllua.o

REGRESS = create_ext hstore

# MAJORVERSION and includedir_server are not defined yet, but will be
# defined before PG_CPPFLAGS is expanded

# for pg11+, hstore.h will have been installed here as hstore/hstore.h,
# but pllua.h might also have been installed as pllua/pllua.h and we don't
# want to take that in preference to ../src/pllua.h. So we use
# #include "hstore/hstore.h" but #include "pllua.h"

EXT_INCDIR = $(includedir_server)/extension

# for pg 9.5/9.6/10, we have a local copy of hstore.h since it happens
# to be the same, barring non-semantic whitespace, between the three
# versions
EXT_INCDIR_OLD = $(srcdir)/old_inc

PG_CPPFLAGS = -I$(LUA_INCDIR) -I$(srcdir)/../src
PG_CPPFLAGS += -I$(EXT_INCDIR$(if $(call version_ge,$(MAJORVERSION),11),,_OLD))

SHLIB_LINK = $(LUALIB)

# if VPATH is not already set, but the makefile is not in the current
# dir, then assume a vpath build using the makefile's directory as
# source. PGXS will set $(srcdir) accordingly.
ifndef VPATH
ifneq ($(realpath $(CURDIR)),$(realpath $(dir $(firstword $(MAKEFILE_LIST)))))
VPATH := $(dir $(firstword $(MAKEFILE_LIST)))
endif
endif

mklibdir := $(if $(VPATH),$(VPATH)/../tools,../tools)
include $(mklibdir)/numeric.mk

PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)

ifeq ($(call version_ge,$(MAJORVERSION),9.5),)
$(error unsupported PostgreSQL version)
endif

=== debian/changelog ===
postgresql-pllua (1:2.0.12-6) unstable; urgency=medium

  * Upload for PostgreSQL 18. (Closes: #1117325)
  * Add ${postgresql:Breaks}.
  * debian/tests: Depend on postgresql-common-dev instead of 'make'.

 -- Christoph Berg <myon@debian.org>  Wed, 08 Oct 2025 19:48:04 +0200

postgresql-pllua (1:2.0.12-5) unstable; urgency=medium

  * Support PostgreSQL 18.

 -- Christoph Berg <myon@debian.org>  Mon, 28 Apr 2025 09:59:45 +0000

postgresql-pllua (1:2.0.12-4) unstable; urgency=medium

  * Mark lua object as not needing an executable stack. (Closes: #1096038)

 -- Christoph Berg <myon@debian.org>  Fri, 28 Feb 2025 14:31:37 +0100

postgresql-pllua (1:2.0.12-3) unstable; urgency=medium

  * Upload for PostgreSQL 17.
  * Restrict to 64-bit architectures.
  * Mark postgresql-all as <!nocheck>.

 -- Christoph Berg <myon@debian.org>  Sat, 14 Sep 2024 23:40:03 +0200

postgresql-pllua (1:2.0.12-2) unstable; urgency=medium

  * Upload for PostgreSQL 16.

 -- Christoph Berg <myon@debian.org>  Mon, 18 Sep 2023 19:34:58 +0000

postgresql-pllua (1:2.0.12-1) unstable; urgency=medium

  * New upstream version with PG16 support.

 -- Christoph Berg <myon@debian.org>  Sat, 29 Jul 2023 21:25:57 +0200

=== debian/control ===
Source: postgresql-pllua
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-64-bit <!pkg.postgresql.32-bit>,
 liblua5.3-dev,
 lua5.3,
 postgresql-all <!nocheck>,
 postgresql-server-dev-all,
Standards-Version: 4.7.2
Homepage: https://github.com/pllua/pllua
Vcs-Git: https://salsa.debian.org/postgresql/postgresql-pllua.git
Vcs-Browser: https://salsa.debian.org/postgresql/postgresql-pllua

Package: postgresql-18-pllua
Architecture: any
Depends:
 postgresql-contrib-18,
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
Breaks:
 ${postgresql:Breaks},
Description: Lua procedural language for PostgreSQL 18
 PL/Lua is an implementation of Lua as a loadable procedural language for
 PostgreSQL: with PL/Lua you can use PostgreSQL functions and triggers
 written in the Lua programming language.
 .
 It brings the power and simplicity of Lua to PostgreSQL, including:
 small memory footprint, simple syntax, lexical scoping, functions as
 first-class values, and coroutines for non-preemptive threading.
 .
 This package is based on pllua-ng.

=== debian/tests/control ===
Depends:
 lua5.3,
 postgresql-common-dev,
 @,
Test-Command: LUA=lua5.3 pg_buildext installcheck
Restrictions:
 allow-stderr,
Features:
 test-name=installcheck-pllua,

Depends:
 postgresql-all,
 postgresql-common-dev,
 @,
Test-Command: pg_buildext installcheck hstore
Restrictions:
 allow-stderr,
Features:
 test-name=installcheck-pllua-hstore,

=== debian/watch ===
version=4
options="uversionmangle=s/_BETA/~beta/;s/_RC/~rc/;s/_/./g" \
https://github.com/pllua/pllua-ng/tags .*/REL_(.*).tar.gz
